<?php
namespace App\CheckoutFunctions;
use App\Helper\Helper;

class checkoutFunctions {

    private $helperObj;

    public function __construct() {

      $this->helperObj = new Helper();
    }

    private $logDirectory;

    public function properties($value) {
    
        if($value) {
            $object = (object) ['properties' => $value];
        } else {
            $object = (object) [];
        }

        return $object;

    }

    public function setCheckoutColumns() {

        $checkoutFields = array("order_id", "product_id", "title", "grams",
        "line_price", "price", "properties", "quantity",
        "requires_shipping", "sku", "taxable", "variant_id",
        "variant_title", "vendor", "note_attributes", "address1", "address2", "city",
        "company", "country", "first_name", "last_name", "phone", 
        "province", "zip", "email", "checkout_token", "status");
        return $checkoutFields;
    }

    public function getCheckoutData($orderNumber = 0, $postData, $checkoutToken, $method) {
     
     if($method == 'create') {
        $checkoutData = array($orderNumber, $postData->input('product_id'), 
        $postData->input('title'), $postData->input('grams'), $postData->input('line_price'), $postData->input('price'), 
        $postData->input('properties'), $postData->input('quantity'), 
        $postData->input('requires_shipping'), $postData->input('sku'), $postData->input('taxable'), 
        $postData->input('variant_id'), $postData->input('variant_title'), $postData->input('vendor'), 
        $postData->input('note_attributes'), 
        $postData->input('address1'), $postData->input('address2'), $postData->input('city'), 
        $postData->input('company'), $postData->input('country'), $postData->input('first_name'), 
        $postData->input('last_name'), $postData->input('phone'), $postData->input('province'), 
        $postData->input('zip'), $postData->input('email'), $checkoutToken, 'checkedout');  
     } elseif ($method == 'update') {
        $checkoutData = array($postData->input('order_id'), $postData->input('product_id'), $postData->input('title'),
        $postData->input('grams'), $postData->input('line_price'), $postData->input('price'), 
        $postData->input('properties'), $postData->input('quantity'), 
        $postData->input('requires_shipping'), $postData->input('sku'), $postData->input('taxable'), 
        $postData->input('variant_id'), $postData->input('variant_title'), $postData->input('vendor'), $postData->input('note_attributes'), 
        $postData->input('address1'), $postData->input('address2'), $postData->input('city'), 
        $postData->input('company'), $postData->input('country'), $postData->input('first_name'), 
        $postData->input('last_name'), $postData->input('phone'), $postData->input('province'), 
        $postData->input('zip'), $postData->input('email'), $checkoutToken, 'checkedout');  
    }
          return $checkoutData;
        

    }

    public function getOrderNumber($fileName) {

        $checkoutDetails = $this->helperObj->getReadCsvDetails($fileName);
        if(!empty($checkoutDetails))
        {
         $orderCount = count($checkoutDetails);
         $currentOrderCount = $checkoutDetails[$orderCount - 1]['order_id'];
         return $currentOrderCount + 1;
        } else {
            return 1;
        }
    }

    public function writeCheckoutDetails($checkoutData, $fileName, $fileMode) {

        $filePointer = fopen($fileName, $fileMode);
        fputcsv($filePointer, $checkoutData);
        fclose($filePointer);
    }

    public function updateCheckoutCSVDetails($checkoutFields, $checkoutData, $csvPath, $orderID) {
        $currentCheckoutData = 
        $this->helperObj->getReadCsvDetails($csvPath);
        $filePointer = fopen($csvPath,"w");
        fputcsv($filePointer, $checkoutFields);
        fclose($filePointer);
        $filePointer = fopen($csvPath, "a");
        foreach ($currentCheckoutData as $csvDataValue) {
            if(trim($csvDataValue['order_id']) == trim($orderID)) {
             $updatedData = $this->updateCheckoutData($checkoutData);
             fputcsv($filePointer, $updatedData);
            } else {
             fputcsv($filePointer, $csvDataValue);   
            }
        }
        fclose($filePointer);
    }

    public function updateCheckoutData($checkoutData) {

        foreach ($checkoutData as $dataValue) {
            $updatedData[] = $dataValue;
        }
        return $updatedData;

    }

}